SystemOrganization addCategory: #'OB-Mondrian-Diagrams'!

OBPanel subclass: #OBCodeTabPanel
	instanceVariableNames: 'definitionPanel selection commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Mondrian-Diagrams'!

!OBCodeTabPanel methodsFor: 'morphic' stamp: 'dr 7/18/2007 15:37'!
buildOn: aBuilder
     ^aBuilder codeTabPanel: self with: []! !

!OBCodeTabPanel methodsFor: 'configuration' stamp: 'dr 7/12/2007 14:27'!
cellInset
    ^5! !

!OBCodeTabPanel methodsFor: 'callbacks' stamp: 'dr 6/22/2007 17:00'!
color
	^browser defaultBackgroundColor ! !

!OBCodeTabPanel methodsFor: 'callbacks' stamp: 'dr 7/3/2007 15:04'!
commands
	| tmpCommands |
	self node ifNil: [^ #()].
	tmpCommands _ (self announce: OBNodeCommandScan) commandsOn: self node for: self. 
	commands := (tmpCommands select: [:ea | ea wantsTabButton]) asSortedCollection: [:a :b | (a priority < b priority) or: [a priority = b priority and: [a label <= b label]]].
	^commands! !

!OBCodeTabPanel methodsFor: 'configuration' stamp: 'dr 7/19/2007 16:05'!
defaultLabelSelector
    ^#shortLabel! !

!OBCodeTabPanel methodsFor: 'accessing' stamp: 'dr 6/28/2007 10:58'!
definitionPanel
    ^definitionPanel! !

!OBCodeTabPanel methodsFor: 'accessing' stamp: 'dr 6/28/2007 10:45'!
definitionPanel: aDefinitionPanel
    definitionPanel := aDefinitionPanel! !

!OBCodeTabPanel methodsFor: 'executing' stamp: 'dr 10/19/2007 14:33'!
executeCommand
     (commands at: self selection) execute.! !

!OBCodeTabPanel methodsFor: 'initializing' stamp: 'dr 6/29/2007 16:26'!
initialize
    super initialize.
    selection := 1.! !

!OBCodeTabPanel methodsFor: 'testing' stamp: 'dr 7/19/2007 16:06'!
isEnabled: aButtonModel
    ^(self commands detect: [:ea | (ea perform: self defaultLabelSelector) = aButtonModel label] 
                        ifNone: [^false]) isActive.! !

!OBCodeTabPanel methodsFor: 'testing' stamp: 'dr 10/19/2007 14:32'!
isSourceTabSelected
   ^self selection = 1! !

!OBCodeTabPanel methodsFor: 'testing' stamp: 'dr 6/28/2007 10:37'!
isTab
    ^true! !

!OBCodeTabPanel methodsFor: 'callbacks' stamp: 'dr 7/19/2007 16:05'!
list 
    ^self commands collect: [:ea | ea perform: self defaultLabelSelector]! !

!OBCodeTabPanel methodsFor: 'morphic' stamp: 'dr 7/12/2007 14:32'!
maxWidth
    ^self commands inject: 0 into: [:width :cmd | width := width + (cmd label size * 7 + self cellInset). width]! !

!OBCodeTabPanel methodsFor: 'accessing' stamp: 'dr 7/19/2007 16:01'!
node
    ^self definitionPanel currentOrRootNode! !

!OBCodeTabPanel methodsFor: 'accessing' stamp: 'dr 6/22/2007 17:19'!
panel
    ^self! !

!OBCodeTabPanel methodsFor: 'executing' stamp: 'dr 10/19/2007 13:55'!
selectFirst
    commands ifNotNil: [self selection: 1]! !

!OBCodeTabPanel methodsFor: 'accessing' stamp: 'dr 6/28/2007 16:07'!
selection
	^selection! !

!OBCodeTabPanel methodsFor: 'accessing' stamp: 'dr 7/12/2007 14:56'!
selection: anInteger
	selection := anInteger.
     self executeCommand.
	self changed: #selection.! !

!OBCodeTabPanel methodsFor: 'callbacks' stamp: 'dr 7/19/2007 14:54'!
selectionChanged: ann
	self changed: #list! !

!OBCodeTabPanel methodsFor: 'callbacks' stamp: 'dr 6/29/2007 14:21'!
subscribe
	self announcer
		observe: OBSelectionChanged
		send: #selectionChanged:
		to: self! !

OBCommand subclass: #OBCmdClassBlueprint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Mondrian-Diagrams'!

!OBCmdClassBlueprint methodsFor: 'configuration' stamp: 'dr 10/22/2007 11:41'!
blueprintSelector
    ^#classBlueprint! !

!OBCmdClassBlueprint methodsFor: 'command' stamp: 'dr 10/22/2007 11:38'!
execute
     | defPanel mondrianPanel |
     defPanel := requestor definitionPanel.
     mondrianPanel := OBMondrianPanel new browser: defPanel browser; node: defPanel node.
	defPanel exchangeContentWith: (mondrianPanel perform: self blueprintSelector).! !

!OBCmdClassBlueprint methodsFor: 'command' stamp: 'dr 7/3/2007 14:57'!
group
	^ #identity! !

!OBCmdClassBlueprint methodsFor: 'testing' stamp: 'dr 7/3/2007 14:57'!
isActive
	^(requestor isKindOf: OBCodeTabPanel) and: [target respondsTo: #theClass]! !

!OBCmdClassBlueprint methodsFor: 'command' stamp: 'dr 7/3/2007 14:57'!
label
    ^'Class Blueprint'! !

!OBCmdClassBlueprint methodsFor: 'sorting' stamp: 'dr 7/3/2007 15:00'!
priority
    ^2! !

!OBCmdClassBlueprint methodsFor: 'command' stamp: 'dr 7/12/2007 14:35'!
shortLabel
    ^'Cl. Bluep.'! !

!OBCmdClassBlueprint methodsFor: 'testing' stamp: 'dr 7/3/2007 14:57'!
wantsTabButton
    ^true! !

OBCmdClassBlueprint subclass: #OBCmdDynamicClassBlueprint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Mondrian-Diagrams'!

!OBCmdDynamicClassBlueprint methodsFor: 'configuration' stamp: 'dr 10/22/2007 11:41'!
blueprintSelector
    ^#dynamicClassBlueprint! !

!OBCmdDynamicClassBlueprint methodsFor: 'testing' stamp: 'dr 12/6/2007 11:56'!
isActive 
    ^Smalltalk includesKey: #HODataBase.! !

!OBCmdDynamicClassBlueprint methodsFor: 'command' stamp: 'dr 10/22/2007 11:04'!
label
    ^'Class Blueprint dynamic'! !

!OBCmdDynamicClassBlueprint methodsFor: 'command' stamp: 'dr 10/22/2007 11:05'!
shortLabel
    ^'Cl. Bluep. (dy.)'! !

!OBCmdDynamicClassBlueprint methodsFor: 'testing' stamp: 'dr 12/6/2007 11:57'!
wantsTabButton 
    ^Smalltalk includesKey: #HODataBase.! !

OBCommand subclass: #OBCmdSourceCode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Mondrian-Diagrams'!

!OBCmdSourceCode methodsFor: 'command' stamp: 'dr 10/19/2007 14:28'!
execute
	requestor definitionPanel changeToSourceCodePanel! !

!OBCmdSourceCode methodsFor: 'command' stamp: 'dr 6/28/2007 10:28'!
group
	^ #identity! !

!OBCmdSourceCode methodsFor: 'testing' stamp: 'dr 7/19/2007 15:04'!
isActive
	^requestor isKindOf: OBCodeTabPanel! !

!OBCmdSourceCode methodsFor: 'command' stamp: 'dr 6/28/2007 10:27'!
label
    ^'Source Code'! !

!OBCmdSourceCode methodsFor: 'sorting' stamp: 'dr 7/3/2007 15:01'!
priority
    ^1! !

!OBCmdSourceCode methodsFor: 'command' stamp: 'dr 7/12/2007 14:36'!
shortLabel
    ^'Src C.'! !

!OBCmdSourceCode methodsFor: 'testing' stamp: 'dr 6/28/2007 16:25'!
wantsTabButton
    ^true! !

OBCommand subclass: #OBCmdSystemComplexity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Mondrian-Diagrams'!

!OBCmdSystemComplexity methodsFor: 'command' stamp: 'dr 7/19/2007 15:22'!
execute
     | defPanel mondrianPanel |
     defPanel := requestor definitionPanel.
     mondrianPanel := OBMondrianPanel new browser: defPanel browser; node: defPanel node.
	defPanel exchangeContentWith: mondrianPanel systemComplexity.! !

!OBCmdSystemComplexity methodsFor: 'command' stamp: 'dr 6/15/2007 16:49'!
group
	^ #identity! !

!OBCmdSystemComplexity methodsFor: 'testing' stamp: 'dr 6/28/2007 11:24'!
isActive
	^(requestor isKindOf: OBCodeTabPanel) and: [target respondsTo: #theClass]! !

!OBCmdSystemComplexity methodsFor: 'command' stamp: 'dr 6/15/2007 16:49'!
label
    ^'System Complexity'! !

!OBCmdSystemComplexity methodsFor: 'sorting' stamp: 'dr 7/3/2007 15:02'!
priority
    ^2! !

!OBCmdSystemComplexity methodsFor: 'command' stamp: 'dr 7/12/2007 14:34'!
shortLabel
    ^'Sys. Complex.'! !

!OBCmdSystemComplexity methodsFor: 'testing' stamp: 'dr 6/28/2007 16:24'!
wantsTabButton
    ^true! !

OBCommand subclass: #OBCmdUmlDiagram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Mondrian-Diagrams'!

!OBCmdUmlDiagram methodsFor: 'command' stamp: 'dr 7/19/2007 15:25'!
execute
     | defPanel mondrianPanel |
     defPanel := requestor definitionPanel.
     mondrianPanel := OBMondrianPanel new browser: defPanel browser; node: defPanel node.
	defPanel exchangeContentWith: mondrianPanel umlDiagram.! !

!OBCmdUmlDiagram methodsFor: 'command' stamp: 'dr 6/19/2007 15:58'!
group
	^ #identity! !

!OBCmdUmlDiagram methodsFor: 'testing' stamp: 'dr 7/16/2007 12:06'!
isActive
	^(requestor isKindOf: OBCodeTabPanel) and: [target respondsTo: #theClass]! !

!OBCmdUmlDiagram methodsFor: 'command' stamp: 'dr 6/19/2007 15:58'!
label
    ^'UML Diagram'! !

!OBCmdUmlDiagram methodsFor: 'sorting' stamp: 'dr 7/3/2007 15:02'!
priority
    ^2! !

!OBCmdUmlDiagram methodsFor: 'command' stamp: 'dr 7/12/2007 14:34'!
shortLabel
    ^'UML Diag.'! !

!OBCmdUmlDiagram methodsFor: 'testing' stamp: 'dr 6/28/2007 16:25'!
wantsTabButton
    ^true! !

!OBPackageBrowser methodsFor: '*ob-mondrian-diagrams' stamp: 'dr 10/17/2007 16:00'!
cmdClassBlueprint
	^OBCmdClassBlueprint! !

!OBPackageBrowser methodsFor: '*ob-mondrian-diagrams' stamp: 'dr 10/22/2007 11:05'!
cmdDynamicClassBlueprint
	^OBCmdDynamicClassBlueprint! !

!OBPackageBrowser methodsFor: '*ob-mondrian-diagrams' stamp: 'dr 10/17/2007 16:00'!
cmdSourceCode
	^ OBCmdSourceCode! !

!OBPackageBrowser methodsFor: '*ob-mondrian-diagrams' stamp: 'dr 10/17/2007 16:00'!
cmdSystemComplexity
	^ OBCmdSystemComplexity! !

!OBPackageBrowser methodsFor: '*ob-mondrian-diagrams' stamp: 'dr 10/17/2007 16:00'!
cmdUmlDiagram
	^OBCmdUmlDiagram! !

!OBClosableDefinitionPanel methodsFor: '*ob-mondrian-diagrams' stamp: 'dr 6/29/2007 15:22'!
codeTabPanel
    codeTabPanel ifNil: [codeTabPanel := (OBCodeTabPanel new browser: browser; definitionPanel: self; yourself)].
    ^codeTabPanel! !
